Bug 73434 - MacroAssemblerSH4 does not implement readCallTarget
: MacroAssemblerSH4 does not implement readCallTarget
Status: RESOLVED FIXED
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore
: 528+ (Nightly build)
: All All
: P1 Blocker
Assigned To: Nobody
:
Depends on: 73667
Blocks:
  Show dependency treegraph
 
Reported: 2011-11-30 05:00 PST by Csaba Osztrogonác
Modified: 2011-12-05 01:41 PST (History)
9 users (show)

See Also:


Attachments
speculative patch (1.83 KB, patch)
2011-12-01 04:00 PST, Zoltan Herczeg
no flags Details | Formatted Diff | Diff
another attempt (2.50 KB, patch)
2011-12-05 00:39 PST, Zoltan Herczeg
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Csaba Osztrogonác 2011-11-30 05:00:38 PST
It is blocker bug, beacuse after http://trac.webkit.org/changeset/101457
Qt-SH4 build is broken. (and all other MIPS build of course)
Comment 1 Zoltan Herczeg 2011-12-01 04:00:36 PST
Created attachment 117392 [details]
speculative patch

Could someone who has such machine try this fix first?
Comment 2 thouraya 2011-12-02 00:44:53 PST
Hi,

I'll try it today.

Regards,
Thouraya.

(In reply to comment #1)
> Created an attachment (id=117392) [details]
> speculative patch
> 
> Could someone who has such machine try this fix first?
Comment 3 thouraya 2011-12-02 06:41:00 PST
Hi, 

1509    static FunctionPtr readCallTarget(CodeLocationCall call)
>> CodeLocationCall  not defined in SH4Assembler.h
 1510    {
 1511        uint16_t* instructionPtr = call.dataLocation();
 1512        instructionPtr -= 3;
 1513        uint32_t addr = readPCrelativeAddress((*instructionPtr & 0xff), instructionPtr)
>> missed ;
 1514        return FunctionPtr(reinterpret_cast<void(*)()>(addr);
>> missed )
 1515    }


Regard,
Thouraya.
Comment 4 Zoltan Herczeg 2011-12-02 07:08:05 PST
Does it work (except the typos)?
Comment 5 thouraya 2011-12-02 07:09:38 PST
Yes it works.

(In reply to comment #4)
> Does it work (except the typos)?
Comment 6 Csaba Osztrogonác 2011-12-02 08:28:03 PST
Comment on attachment 117392 [details]
speculative patch

r=me with fixing typos mentioned in Comment #3
Comment 7 Csaba Osztrogonác 2011-12-02 08:31:14 PST
Comment on attachment 117392 [details]
speculative patch

Landed with typo fixes in http://trac.webkit.org/changeset/101801
Comment 8 Csaba Osztrogonác 2011-12-02 09:03:33 PST
Reopen, because build is still broken:

../../../../Source/JavaScriptCore/assembler/SH4Assembler.h:1509:39: error: 'CodeLocationCall' has not been declared../../../../Source/JavaScriptCore/assembler/SH4Assembler.h: In static member function 'static JSC::FunctionPtr JSC::SH4Assembler::readCallTarget(int)':
../../../../Source/JavaScriptCore/assembler/SH4Assembler.h:1511:41: error: request for member 'dataLocation' in 'call', which is of non-class type 'int'

It would be better if we make a similar change to ARM and MIPS:
- http://trac.webkit.org/changeset/101658
- http://trac.webkit.org/changeset/101473
Comment 9 Zoltan Herczeg 2011-12-02 09:38:30 PST
CodeLocationCall is an int???
Comment 10 Eric Seidel 2011-12-02 15:17:01 PST
Does not appear to have fixed things:
http://build.webkit.org/builders/Qt%20Linux%20SH4%20Release/builds/2703/steps/compile-webkit/logs/stdio
Comment 11 Zoltan Herczeg 2011-12-02 22:30:10 PST
../../../../Source/JavaScriptCore/jit/JITPropertyAccess.cpp: In static member function 'static bool JSC::JIT::isDirectPutById(JSC::StructureStubInfo*)':
../../../../Source/JavaScriptCore/jit/JITPropertyAccess.cpp:1160:25: error: 'readCallTarget' is not a member of 'JSC::MacroAssembler'

So I put it into a wrong file. We should move it to MacroAssemblerSH4.
Comment 12 Zoltan Herczeg 2011-12-05 00:39:47 PST
Created attachment 117853 [details]
another attempt
Comment 13 Csaba Osztrogonác 2011-12-05 00:41:39 PST
Comment on attachment 117853 [details]
another attempt

Let's see, r=me.
Comment 14 Csaba Osztrogonác 2011-12-05 01:41:15 PST
Comment on attachment 117853 [details]
another attempt

Clearing flags on attachment: 117853

Committed r101980: <http://trac.webkit.org/changeset/101980>
Comment 15 Csaba Osztrogonác 2011-12-05 01:41:24 PST
All reviewed patches have been landed.  Closing bug.